//
//  NSString+Gudge.m
//  TextGudge
//
//  Created by xsw on 16/6/3.
//  Copyright © 2016年 xsw. All rights reserved.
//

#import "NSString+Gudge.h"

@implementation NSString (Gudge)
- (BOOL)email
{
    NSString *emailEx =
    @"(?:[a-z0-9!#$%\\&'*+/=?\\^_`{|}~-]+(?:\\.[a-z0-9!#$%\\&'*+/=?\\^_`{|}"
    @"~-]+)*|\"(?:[\\x01-\\x08\\x0b\\x0c\\x0e-\\x1f\\x21\\x23-\\x5b\\x5d-\\"
    @"x7f]|\\\\[\\x01-\\x09\\x0b\\x0c\\x0e-\\x7f])*\")@(?:(?:[a-z0-9](?:[a-"
    @"z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\\[(?:(?:25[0-5"
    @"]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-"
    @"9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\\x01-\\x08\\x0b\\x0c\\x0e-\\x1f\\x21"
    @"-\\x5a\\x53-\\x7f]|\\\\[\\x01-\\x09\\x0b\\x0c\\x0e-\\x7f])+)\\])";
    
    NSPredicate *regExPredicate = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", emailEx];
    return [regExPredicate evaluateWithObject:[self lowercaseString]];
}

- (BOOL)weakPswd
{
    NSString *pswdEx =
    @"^(?=.*\\d.*)(?=.*[a-zA-Z].*).{6,20}$";
    NSPredicate *regExPredicate = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", pswdEx];
    return [regExPredicate evaluateWithObject:self];
}
- (BOOL)emptyOrWhitespace
{
    return self == nil || !([self length] > 0) || [[self trimmedString] length] == 0;
}

- (NSString *)trimmedString
{
    return [self stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
}

- (NSString *)trimmedWhitespaceAndNewlineString
{
    return [self stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
}

- (BOOL)telephone
{
    NSString * MOBILE = @"^1(3[0-9]|5[0-35-9]|8[025-9])\\d{8}$";
    NSString * cm = @"^1(34[0-8]|(3[5-9]|5[017-9]|8[278])\\d)\\d{7}$";
    NSString * cu = @"^1(3[0-2]|5[256]|8[56])\\d{8}$";
    NSString * ct = @"^1((33|53|8[09])[0-9]|349)\\d{7}$";
    NSString * phs = @"^0(10|2[0-5789]|\\d{3})\\d{7,8}$";
    NSPredicate *regexmobile = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", MOBILE];
    NSPredicate *regexcm = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", cm];
    NSPredicate *regexcu = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", cu];
    NSPredicate *regexct = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", ct];
    NSPredicate *regexphs = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", phs];
    
    return  [regexmobile evaluateWithObject:self]   ||
    [regexphs evaluateWithObject:self]      ||
    [regexct evaluateWithObject:self]       ||
    [regexcu evaluateWithObject:self]       ||
    [regexcm evaluateWithObject:self];
}


@end
